#include "main.h"
#include <time.h>

stackptr trashstack=NULL; 
list * catasta=NULL;

int main (int argc,char *argv[])
{
	int f_in = 0,i = 0;
	int howmanydirs=0,lastprocess=0,processed=0,id=0,index=0,flag=0,retvalchild;
	char *file_input = NULL; 
	for(i = 0;i < MAXLEN;i++)
	{
		f_data.file_out[i] = '\0';
	}
	
	/*Controllo la sintassi di esecuzione del comando */
	if(argc != 2)
	{
		printf("\nLa sintassi : ./progettino file\n");
		exit(1);
	}

	file_input = argv[1];
	
	/*Tento di aprire il file ricevuto in input,esce in caso di errore nell'apertura*/
	if((f_in=open(file_input,O_RDONLY)) < 0) {
		printf("Errore nell'apertura del file %s\n",file_input);
		perror("open");
		exit(0);
	}

	/*Inizio a leggere dal file specificato il nome del file di output*/
	leggi_fileout(f_in,f_data.file_out);
	/*Leggo la data di soglia */
	f_data.soglia = leggi_soglia(f_in);
	/*Leggo il numero massimo di processi da utilizzare*/
	f_data.nproc = leggi_nproc(f_in);
	/*Leggo l'elenco dei pathnames da esplorare*/
	leggi_path(f_in,&f_data.npath,f_data.pathnames);

// 	creafigli();
	if(f_data.npath< f_data.nproc)	//agiornare i campi
		f_data.nproc=f_data.npath;	/*se il numero di path  minore dei processi 
						*disponibili, diminuisci il numero di processi*/
	
	howmanydirs=f_data.npath/f_data.nproc;	/*il numero di path che ogni processo figlio dovr espolrare*/
	lastprocess=howmanydirs+(f_data.npath%f_data.nproc);	/*numero di path per l'ultimo processo*/


	if((creat(f_data.file_out,S_IRWXU))==-1)
	{//creo il file
		perror("open");
		exit(1);
	}
	
	for(index=0;index<f_data.nproc;index++)
	{
		switch(id=fork())
		{
			case -1:
				perror("fork");
				break;
			case 0:
				
				for(flag=0;flag<howmanydirs;flag++)
				{
					pushtrash(f_data.pathnames[flag+processed]);//sostituire con dirp->pathnames[flag]
					explorepath();
				}
				//printlist(catasta);
				list2file(catasta,f_data.file_out);
				exit(retvalchild);
			default:
				
				processed=processed+howmanydirs;//aggiorno il numero di path finora processati
				if((processed+lastprocess)==f_data.npath)	howmanydirs=lastprocess;/*se  l'ultimo processo aggiorna l'indice di path da esplorare per l'ultimo processo*/
				break;
		}
	}
	
	index=0;
	while(index<f_data.nproc)
	{
		wait(&retvalchild);
		index++;
	}
	exit(0);
}



void pushtrash(char *addpath)
{/*aggiunge un path da visitare*/
	int len=0;
	stackptr new=NULL;

	new=(stackptr)malloc(sizeof(stack));
	len=strlen(addpath);
	new->path=(char *)calloc(1,(len+1)*sizeof(char));
	new->path=strncpy(new->path,addpath,len+1);
	new->next=trashstack;
	trashstack=new;
	
	return;
}


void poptrash()
{/*elimina il path che si sta visitando*/
	stackptr temp=NULL;
	temp=trashstack;
	trashstack=trashstack->next;
	free(temp);
	return;
}



/*	PREC: Date deve essere un tipo valido,path non deve essere nullo
 *	POST:ritorna 1 in caso di ricerca terminata correttamente 0 in caso di errore
 */
void explorepath()/*N.B. il tipo ella data e da rividere*/
{/*esplora un path dato in input salvando in uno stack
	*una serie di files con crazione/ultima modifica 
	*precedente ad un data prestabilita
 */
	//per aprire il filedescriptor
	DIR *current_ptr = NULL;
	//varibile di appoggio per leggere nel file descriptor
	struct dirent *current_dirent = NULL;
	struct stat statbuf;
	//path nuovo da aggiungere allo stack di ricerca
	char *path=NULL;
	//cwd e la directory dove si sta svolgendo la ricerca
	char *cwd=NULL;
	//interi di appoggio per la costruzione delle stringhe
	int len=0,lencwd=0;
	//struct di appoggio per la conversione del tipo time_t in tm
	struct tm *tm_convert;

	if(trashstack==NULL) {
		return;	/*caso base, se lo stack di ricerca  vuoto ritorna*/
	}
	else
	{
		if (!(current_ptr=opendir(trashstack->path)))
		{/*apre la directory
			*se non ci riesce  elimina il path errato e da errore
		 *continua l'esplorazione e ritorna*/
			perror("opendir");
			poptrash();
			explorepath();
			return;
		}
		lencwd=strlen(trashstack->path);//controllo la lunghezza
		cwd=(char *)malloc((lencwd+1)*sizeof(char));//alloco lo spazio necessario
		cwd=strncpy(cwd,trashstack->path,lencwd+1);//copio il path di ricerca
		poptrash();//elimina subito il path attuale di ricerca dallo stack
		

		while((current_dirent = readdir(current_ptr))!= NULL)
		{//finch c' qualcosa dentro la directory
			if(current_dirent->d_type==DT_DIR)//se  una directory
			{
// 				printf("\nVISITING %s",current_dirent->d_name);
				/*elimina i path speciali ., .., lost+found 
				*e tutti i files e directory nascoste
			char *strptime(const char *s, const char *format, struct tm *tm);	*/
				if( current_dirent->d_name[0]=='.' || (strcmp(current_dirent->d_name,"lost+found"))==0)
				{
				}
				else
				{/*costruzione del prossimo path di ricerca*/
					
					len=strlen(current_dirent->d_name);		//lunghezza della nuova directory
					path=(char *)calloc(1,(lencwd+len+2)*sizeof(char));//alloco lo spazio totale richiesto
					path=strncat(path,cwd,lencwd);			//concateno il path iniziale
					path=strncat(path,"/",1);			//aggiungo uno '/'
					path=strncat(path,current_dirent->d_name,len);	//aggiungo la directory trovata
					path=strncat(path,"\0",1);			//aggiungo il carattere terminatore
					pushtrash(path);					//aggiunge il path allo stack
					free(path);					//liberiamo un p di memoria
					path=NULL;
				}
			}
			else
			{
				if(current_dirent->d_type==DT_REG)
				{
					if(current_dirent->d_name[0]!='.')
					{
						len=strlen(current_dirent->d_name);		//lunghezza della nuova directory
						path=(char *)calloc(1,(lencwd+len+2)*sizeof(char));//alloco lo spazio totale richiesto
						path=strncat(path,cwd,lencwd);			//concateno il path iniziale
						path=strncat(path,"/",1);			//aggiungo uno '/'
						path=strncat(path,current_dirent->d_name,len);	//aggiungo la directory trovata 
						path=strncat(path,"\0",1);			//aggiungo il carattere terminatore
							
						if (stat(path,&statbuf) == -1) 
						{
							perror("stat");
						}
						else
						{
	
							tm_convert=localtime(&statbuf.st_mtime);
		
						
							if( f_data.soglia.tm_year >= tm_convert->tm_year)
							{
								if( tm_convert->tm_year < f_data.soglia.tm_year)
								{
									catasta=push(catasta,path);
								}
								else if( tm_convert->tm_year == f_data.soglia.tm_year && tm_convert->tm_mon < f_data.soglia.tm_mon )
								{
									catasta=push(catasta,path);
								}
								else if( tm_convert->tm_year == f_data.soglia.tm_year && tm_convert->tm_mon == f_data.soglia.tm_mon && tm_convert->tm_mday < f_data.soglia.tm_mday )
								{
									catasta=push(catasta,path);
								}
								else if ( tm_convert->tm_year == f_data.soglia.tm_year && tm_convert->tm_mon == f_data.soglia.tm_mon && tm_convert->tm_mday == f_data.soglia.tm_mday && tm_convert->tm_hour < f_data.soglia.tm_hour )
								{
									catasta=push(catasta,path);
								}
								else if ( tm_convert->tm_year == f_data.soglia.tm_year && tm_convert->tm_mon == f_data.soglia.tm_mon && tm_convert->tm_mday == f_data.soglia.tm_mday && tm_convert->tm_hour == f_data.soglia.tm_hour && tm_convert->tm_min < f_data.soglia.tm_min )
								{
									catasta=push(catasta,path);
								}
								else if ( tm_convert->tm_year == f_data.soglia.tm_year && tm_convert->tm_mon == f_data.soglia.tm_mon && tm_convert->tm_mday == f_data.soglia.tm_mday && tm_convert->tm_hour == f_data.soglia.tm_hour && tm_convert->tm_min == f_data.soglia.tm_min && tm_convert->tm_sec < f_data.soglia.tm_sec )
								{
									catasta=push(catasta,path);
								}
								else if ( tm_convert->tm_year == f_data.soglia.tm_year && tm_convert->tm_mon == f_data.soglia.tm_mon && tm_convert->tm_mday == f_data.soglia.tm_mday && tm_convert->tm_hour == f_data.soglia.tm_hour && tm_convert->tm_min == f_data.soglia.tm_min && tm_convert->tm_sec == f_data.soglia.tm_sec )
								{
									catasta=push(catasta,path);
								}
							}
						}
					}
					free(path);
					path=NULL;
				
				}
			
			}
		}
		closedir(current_ptr);
		explorepath();
	}
//	printlist(catasta);
	return;
}

